<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AbstractExecutionExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.executor</a> &gt; <span class="el_source">AbstractExecutionExchange.java</span></div><h1>AbstractExecutionExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.executor;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.function.IntFunction;
import java.util.function.Predicate;
import java.util.function.Supplier;

import io.gitlab.littlesaints.protean.Processor;
import io.gitlab.littlesaints.protean.exchanges.AbstractMessageExchange;
import io.gitlab.littlesaints.protean.exchanges.MessageExchange;

/**
 * @param &lt;E&gt; The getType of objects to execute upon.
 * @author Varun Anand
 * @since 1.0
 */
abstract class AbstractExecutionExchange&lt;E&gt; extends AbstractMessageExchange&lt;E&gt; {

	private final String name;
	final int concurrency;
	final Supplier&lt;Processor&lt;E&gt;&gt; processorSupplier;
	final IntFunction&lt;MessageExchange&lt;E&gt;&gt; exchangeSupplier;

<span class="fc" id="L46">	AbstractExecutionExchange(String name, Supplier&lt;Processor&lt;E&gt;&gt; processorSupplier, int concurrency, IntFunction&lt;MessageExchange&lt;E&gt;&gt; exchangeSupplier) {</span>
<span class="fc" id="L47">		this.name = name;</span>
<span class="fc" id="L48">		this.processorSupplier = processorSupplier;</span>
<span class="fc" id="L49">		this.concurrency = concurrency;</span>
<span class="fc" id="L50">		this.exchangeSupplier = exchangeSupplier;</span>
<span class="fc" id="L51">	}</span>

<span class="fc" id="L53">	protected abstract class _ExecutionExchangeReader implements MessageExchange.Reader&lt;E&gt; {</span>

		abstract Reader&lt;E&gt; getOutputExchangeReader(int idx);

		@Override
		public E poll() {
<span class="fc" id="L59">			E result = null;</span>
<span class="fc bfc" id="L60" title="All 2 branches covered.">			for (int i = 0; i &lt; concurrency; i++) {</span>
<span class="fc bfc" id="L61" title="All 2 branches covered.">				if (getOutputExchangeReader(i) != null) {</span>
<span class="fc" id="L62">					result = getOutputExchangeReader(i).poll();</span>
<span class="fc bfc" id="L63" title="All 2 branches covered.">					if (result != null) {</span>
<span class="fc" id="L64">						break;</span>
					}
				}
			}
<span class="fc" id="L68">			return result;</span>
		}

		@Override
		public List&lt;E&gt; poll(int min, int max, int maxAttempts) {
<span class="nc" id="L73">			List&lt;E&gt; batch = null;</span>
<span class="nc" id="L74">			int currentBatchSize = 0;</span>
			List&lt;E&gt; result;
<span class="nc" id="L76">			final boolean[] doContinue = new boolean[]{true};</span>
<span class="nc bnc" id="L77" title="All 4 branches missed.">			for (int attempts = 0; doContinue[0] &amp;&amp; attempts &lt; maxAttempts; attempts++, Thread.yield()) {</span>
<span class="nc bnc" id="L78" title="All 4 branches missed.">				for (int i = 0; doContinue[0] &amp;&amp; i &lt; concurrency; i++) {</span>
<span class="nc bnc" id="L79" title="All 2 branches missed.">					if (getOutputExchangeReader(i) != null) {</span>
<span class="nc" id="L80">						result = getOutputExchangeReader(i).poll(max - currentBatchSize);</span>
<span class="nc bnc" id="L81" title="All 2 branches missed.">						if (!result.isEmpty()) {</span>
<span class="nc bnc" id="L82" title="All 2 branches missed.">							if (batch == null) {</span>
<span class="nc" id="L83">								batch = new ArrayList&lt;&gt;(min);</span>
							}
<span class="nc" id="L85">							batch.addAll(result);</span>
<span class="nc" id="L86">							currentBatchSize = batch.size();</span>
<span class="nc bnc" id="L87" title="All 2 branches missed.">							if (batch.size() == max) {</span>
<span class="nc" id="L88">								doContinue[0] = false;</span>
							}
<span class="nc" id="L90">							attempts = 0;</span>
<span class="nc bnc" id="L91" title="All 4 branches missed.">						} else if (batch != null &amp;&amp; currentBatchSize &gt;= min) {</span>
<span class="nc" id="L92">							doContinue[0] = false;</span>
						}
					}
				}
			}
<span class="nc bnc" id="L97" title="All 2 branches missed.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public List&lt;E&gt; poll(int max) {
<span class="nc" id="L102">			List&lt;E&gt; batch = null;</span>
<span class="nc" id="L103">			int currentBatchSize = 0;</span>
			List&lt;E&gt; result;
<span class="nc" id="L105">			final boolean[] doContinue = new boolean[]{true};</span>
<span class="nc bnc" id="L106" title="All 4 branches missed.">			for (int i = 0; doContinue[0] &amp;&amp; i &lt; concurrency; i++) {</span>
<span class="nc bnc" id="L107" title="All 2 branches missed.">				if (getOutputExchangeReader(i) != null) {</span>
<span class="nc" id="L108">					result = getOutputExchangeReader(i).poll(max - currentBatchSize);</span>
<span class="nc bnc" id="L109" title="All 2 branches missed.">					if (!result.isEmpty()) {</span>
<span class="nc bnc" id="L110" title="All 2 branches missed.">						if (batch == null) {</span>
<span class="nc" id="L111">							batch = new ArrayList&lt;&gt;();</span>
						}
<span class="nc" id="L113">						batch.addAll(result);</span>
<span class="nc" id="L114">						currentBatchSize = batch.size();</span>
<span class="nc bnc" id="L115" title="All 2 branches missed.">						if (currentBatchSize == max) {</span>
<span class="nc" id="L116">							doContinue[0] = false;</span>
						}
					}
				}
			}
<span class="nc bnc" id="L121" title="All 2 branches missed.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public boolean poll(int maxAttempts, Predicate&lt;? super E&gt; consumer) {
<span class="nc" id="L126">			int attempts = 0;</span>
<span class="nc bnc" id="L127" title="All 2 branches missed.">			for (; attempts &lt; maxAttempts; attempts++) {</span>
<span class="nc bnc" id="L128" title="All 2 branches missed.">				for (int idx = 0; idx &lt; concurrency; idx++) {</span>
<span class="nc bnc" id="L129" title="All 2 branches missed.">					if (getOutputExchangeReader(idx) != null) {</span>
<span class="nc bnc" id="L130" title="All 2 branches missed.">						if (getOutputExchangeReader(idx).poll(1, consumer)) {</span>
<span class="nc" id="L131">							return true;</span>
						}
					}
				}
			}
<span class="nc" id="L136">			return false;</span>
		}

		@Override
		public E take() {
			E result;
<span class="fc bfc" id="L142" title="All 2 branches covered.">			while ((result = poll()) == null) {</span>
				//TODO: wait strategy ??
<span class="fc" id="L144">				Thread.yield();</span>
			}
<span class="fc" id="L146">			return result;</span>
		}

		@Override
		public List&lt;E&gt; take(int min, int max) {
<span class="nc" id="L151">			List&lt;E&gt; batch = null;</span>
<span class="nc" id="L152">			int currentBatchSize = 0;</span>
			List&lt;E&gt; result;
<span class="nc" id="L154">			final boolean[] doContinue = new boolean[]{true};</span>
<span class="nc bnc" id="L155" title="All 2 branches missed.">			for (; doContinue[0]; Thread.yield()) {</span>
<span class="nc bnc" id="L156" title="All 4 branches missed.">				for (int i = 0; doContinue[0] &amp;&amp; i &lt; concurrency; i++) {</span>
<span class="nc bnc" id="L157" title="All 2 branches missed.">					if (getOutputExchangeReader(i) != null) {</span>
<span class="nc" id="L158">						result = getOutputExchangeReader(i).poll(max - currentBatchSize);</span>
<span class="nc bnc" id="L159" title="All 2 branches missed.">						if (!result.isEmpty()) {</span>
<span class="nc bnc" id="L160" title="All 2 branches missed.">							if (batch == null) {</span>
<span class="nc" id="L161">								batch = new ArrayList&lt;&gt;(min);</span>
							}
<span class="nc" id="L163">							batch.addAll(result);</span>
<span class="nc" id="L164">							currentBatchSize = batch.size();</span>
<span class="nc bnc" id="L165" title="All 2 branches missed.">							if (batch.size() == max) {</span>
<span class="nc" id="L166">								doContinue[0] = false;</span>
							}
<span class="nc bnc" id="L168" title="All 4 branches missed.">						} else if (batch != null &amp;&amp; currentBatchSize &gt;= min) {</span>
<span class="nc" id="L169">							doContinue[0] = false;</span>
						}
					}
				}
			}
<span class="nc bnc" id="L174" title="All 2 branches missed.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public List&lt;E&gt; take(int min) {
<span class="nc" id="L179">			List&lt;E&gt; batch = null;</span>
			List&lt;E&gt; result;
<span class="nc" id="L181">			final boolean[] doContinue = new boolean[]{true};</span>
<span class="nc bnc" id="L182" title="All 2 branches missed.">			for (; doContinue[0]; Thread.yield()) {</span>
<span class="nc bnc" id="L183" title="All 4 branches missed.">				for (int i = 0; doContinue[0] &amp;&amp; i &lt; concurrency; i++) {</span>
<span class="nc bnc" id="L184" title="All 2 branches missed.">					if (getOutputExchangeReader(i) != null) {</span>
<span class="nc" id="L185">						result = getOutputExchangeReader(i).poll(Integer.MAX_VALUE);</span>
<span class="nc bnc" id="L186" title="All 2 branches missed.">						if (!result.isEmpty()) {</span>
<span class="nc bnc" id="L187" title="All 2 branches missed.">							if (batch == null) {</span>
<span class="nc" id="L188">								batch = new ArrayList&lt;&gt;(min);</span>
							}
<span class="nc" id="L190">							batch.addAll(result);</span>
<span class="nc bnc" id="L191" title="All 4 branches missed.">						} else if (batch != null &amp;&amp; batch.size() &gt;= min) {</span>
<span class="nc" id="L192">							doContinue[0] = false;</span>
						}
					}
				}
			}
<span class="nc bnc" id="L197" title="All 2 branches missed.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public void take(Predicate&lt;? super E&gt; consumer) {
<span class="nc" id="L202">			for (; ; Thread.yield()) {</span>
<span class="nc bnc" id="L203" title="All 2 branches missed.">				for (int i = 0; i &lt; concurrency; ) {</span>
<span class="nc bnc" id="L204" title="All 2 branches missed.">					if (getOutputExchangeReader(i) != null) {</span>
						//TODO: remove hard-coding
<span class="nc bnc" id="L206" title="All 2 branches missed.">						if (getOutputExchangeReader(i).poll(2, consumer)) {</span>
<span class="nc" id="L207">							return;</span>
						}
					}
				}
			}
		}

	}

	public String getName() {
<span class="fc" id="L217">		return name;</span>
	}

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>